/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F1827
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

#define TIME_OFF -1     //^C}[gpȂꍇ
#define TIME_UP 0       //^CAbv
#define TIME_ADC_WAIT 100
#define TIME_ADC_ERR 500
#define LED_FL 50
#define CHK_CNT 8
#define EMF_BASE 0x19A //2.0V
#define EMF_PPM1000 41 //lႭȂ1
#define EMF_PPM2000 61 //lႭȂ2
#define EMF_CHK_RANGE 4

typedef struct{
  uint8_t wp;
  uint16_t data[CHK_CNT];
  uint16_t avr;
}AI_FILT;

typedef enum{
    AD_AN0 = 0,
    AD_AN0_WAIT,
    AD_AN0_CHK,
}ADC_MODE_NO;

typedef enum{
    MD_IDLE = 0,
    MD_INIT,
    MD_NORMAL,        
}MODE_TYP;

int16_t timAdc;
int16_t timAdcErr;
int16_t timinitLed;

ADC_MODE_NO adcmode;
MODE_TYP mode;
bool initokflg;
uint16_t initvcc;
AI_FILT mg812;
int16_t emf_chk;
int16_t update_chk;

/* vg^Cv錾*/
void mainTimer(void);
void AdcItr(void);
void mainApp(void);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    ADC_SetInterruptHandler(AdcItr);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    IO_RB4_SetHigh();
    
    while (1)
    {
        mainApp();
    }
}

/* ^C}Ǘ֐ */
void mainTimer(void){
    
    if( timAdc > TIME_UP ){
        --timAdc;
    }
    if( timAdcErr > TIME_UP ){
        --timAdcErr;
    }
    if( timinitLed > TIME_UP ){
      timinitLed--;
    }
}

/* C */
void mainApp(void){
    uint8_t i;
    uint16_t sum;

    if( timAdc == TIME_UP){
        timAdc = TIME_ADC_WAIT;
        
        switch(adcmode){
            case AD_AN0:
                ADC_SelectChannel(channel_AN0);
                ADC_StartConversion();
                adcmode = AD_AN0_WAIT;  
                timAdcErr = TIME_ADC_ERR;
                break;
            case AD_AN0_WAIT:
                //ADCϊ҂
                break;
            case AD_AN0_CHK:    
                adcmode = AD_AN0;

                if( initokflg ){
                    sum = 0;
                    for(i = 0;i < CHK_CNT; i++){
                        sum += mg812.data[i];
                    }
                    mg812.avr = sum >> 3;
                    if( mode == MD_IDLE ){
                        mode = MD_INIT;
                    }
                }
                break;
        }
        
        switch(mode){
            case MD_IDLE:
                //ҋ@
                break;
            case MD_INIT:  
                if(initokflg){
                    if( mg812.avr > EMF_BASE ){
                        initvcc = mg812.avr;
                        IO_RB4_SetLow();
                        IO_RB3_SetHigh();
                        mode = MD_NORMAL;
                    }
                }
                break;
            case MD_NORMAL:
                emf_chk = initvcc - mg812.avr; 
                if( emf_chk >= 0){ //CO2Zx㏸
                    //if(emf_chk >= EMF_PPM1000 && emf_chk < EMF_PPM2000 ){
                    if(emf_chk >= EMF_PPM1000 ){    
                        IO_RB4_SetHigh();
                    }
                    else{
                        //LED̐FςȂ炱g
                        IO_RB4_SetLow();
                    }
                }
                else{
                    update_chk = initvcc + EMF_CHK_RANGE;
                            
                    if( mg812.avr >= update_chk ){
                        initvcc = mg812.avr;
                    }
                }
                break;
        }       
    }
    
  if(timinitLed == TIME_UP && mode == MD_NORMAL ){
    timinitLed = LED_FL;
    IO_RB3_Toggle(); 
  }    
    
}
/* ADϊ荞ݏ */
void AdcItr(void){
    
    mg812.data[mg812.wp] = ADC_GetConversionResult(); //xZT[̒l
    adcmode = AD_AN0_CHK;
    timAdcErr = TIME_OFF;
    if( ++mg812.wp >= CHK_CNT ){
        mg812.wp = 0;
        initokflg = true; //f[^܂𔻒
    }
}

/* End of File */